Lua_ArtifactLineupPanel = class("Lua_ArtifactLineupPanel", Lua_DisplayObject);
function Lua_ArtifactLineupPanel:ctor(p)
	self:superCall("ctor", p, "ArtifactLineupPanel_skin");
end

function Lua_ArtifactLineupPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.icon:SetDimensions(0, 0)
	self.icon:addClickFuntion(self, self.onClick);
	self.btnChange:addClickFuntion(self, self.onClick);
end

function Lua_ArtifactLineupPanel:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ArtifactLineupPanel:setData(data, teamIdx)
	self.data = data;

	if data == nil or data[teamIdx] == nil or data[teamIdx] == 0 then
		self.icon:setLocation(0, 0, 0);
		self.icon:setAltas("raccoon_atlas_3", "ui_zd_button_026_n");
		self.icon:resetSize();
		self.btnChange:setAltas("fight_atlas_1", "ui_zd_button_031_n");
		self.levelText:setEnable(false);

		local artifactId = DataCenter.heroLineupData:getUnWearArtifact(data);
		self:showRedDot(artifactId ~= nil);
	else
		local vo = DataCenter.artifactUtil:getArtifactVoById(data[teamIdx]);
		
		self.icon:setLocation(5, 14, 0);
		self.icon:setAltas("raccoon_atlas_3", vo.icon_1);
		self.icon:resetSize();

		self.btnChange:setAltas("fight_atlas_1", "ui_zd_button_001_n");
		self.levelText:setEnable(true);
		self.levelText.text = LanUtil.formateStr(10041, tostring(vo.level));

		self:showRedDot(false);
	end
end

function Lua_ArtifactLineupPanel:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(40, 32, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ArtifactLineupPanel:onClick(go)
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_ArtifactSelectWindow", Lua_WinParam.ACTION_OPEN, self.data);
end