Lua_ArtifactSelectWindow = class("Lua_ArtifactSelectWindow", Lua_Window);
function Lua_ArtifactSelectWindow:ctor()
self:superCall("ctor");
    
    self.h = 1230
    self.windowName = "Lua_ArtifactSelectWindow";
    self.showBlackMask = true;
    self.maskSprite = "black_mask";
    self.blackAlpha = 0.95;
    self.isClickClose = true;
    self.showTitle = true;
    self.titleAtlas = "fight_atlas_1";
    self.titleSprite = "ui_jiesuan_title_1";
    self.titleNameOffsetY = 0;
end

function Lua_ArtifactSelectWindow:buildShowItem()
    self:superCall("buildShowItem");
    self:createCloseTips(0, -571, 0)

    self.itemList = Lua_DragList.new(self.content, 644, 980, Lua_AxisDefine.Vertical);
    self.itemList:setLocation(0, 50, 0);
    self.itemList:setListCell(Lua_ArtifactSelectItem, 644, 245, 1);
end

function Lua_ArtifactSelectWindow:dispose()
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList = nil;
    end
    self:superCall("dispose");
end

function Lua_ArtifactSelectWindow:showWin(param)
    self:superCall("showWin", param);

    self.itemList.customParam = param;
    local arr = DataCenter.artifactUtil:getArtifactArr();
    self.itemList:setArrayData(arr);
    self.itemList.canDrag = not self.itemList.bDragEnd
end




















Lua_ArtifactSelectItem = class("Lua_ArtifactSelectItem", Lua_ListCell);
function Lua_ArtifactSelectItem:ctor(p)
    self:superCall("ctor", p, "ArtifactSelectItem_skin");
end

function Lua_ArtifactSelectItem:buildShowItem()
    self:superCall("buildShowItem");
    self.skillItem = Lua_SkillIconItem.new(self.content);
    self.skillItem.unlock_type = 2;
    self.skillItem.eff_type = 1;
    self.skillItem:setLocation(141, 17, 0);
    self.skillItem:setCanClick(true);

    self.btnFunc:addClickFuntion(self, self.onBtnFuncClick);
end

function Lua_ArtifactSelectItem:dispose()
    if self.skillItem ~= nil then
        self.skillItem:dispose();
        self.skillItem = nil;
    end
    self.customParam = nil;
    self.data = nil;
    self:superCall("dispose");
end

function Lua_ArtifactSelectItem:setCustomParam(customParam)
    self.customParam = customParam;
end

function Lua_ArtifactSelectItem:setData(data)
    self.data = DataCenter.artifactUtil:getArtifactVoById(data);

    self.bg:setUrl(self.data.image_1);
    self.nameText.text = self.data.name
    self.levelText.text = LanUtil.formateStr(10041, tostring(self.data.level))

    self.skillItem.unlock_level = self.data.level;
    self.skillItem:setSkillId(self.data.skill);
    if self.data.clothes_id ~= nil and self.data.clothes_id > 0 then
        local vo = DataCenter.artifactUtil:getClothesVoById(self.data.clothes_id);
        local configData = Lua_SkillConfigData.getConfigData(vo.skill);
        self.skillItem.extra_des = configData.des;
    else
        self.skillItem.extra_des = nil;
    end

    if self.data.is_activate == 0 then
        self.bg:setGray(true)
        self.tagIcon:setEnable(false)
        self.nameText:setGray(true)
        self.levelText:setGray(true)
        self.skillItem:setGray(true)
        self.btnFunc:setStyle(6);
        self.btnFunc:setLangValue(126315);
    else
        self.bg:setGray(false)
        self.nameText:setGray(false)
        self.levelText:setGray(false)
        self.skillItem:setGray(false)
        self.btnFunc:setStyle(1);
        local teamIdx = DataCenter.heroLineupData:getArtifactTeamIdx(self.customParam, data);
        if teamIdx == nil then
            self.tagIcon:setEnable(false)
            self.btnFunc:setLangValue(126313);
        else
            self.tagIcon:setEnable(true)
            self.btnFunc:setLangValue(126314);
        end
    end
end

function Lua_ArtifactSelectItem:onBtnFuncClick(go)
    if self.data == nil then
        return;
    end

    if self.data.is_activate == 0 then
        OperateAlert.show(self.data.unlock_tips);
    else
        Lua_MsgUtil.callFunc("LINEUP_ARTIFACE_SELECT", self.data.id);
        Lua_MsgUtil.callFunc("LineUp_Actifact_LocationInfo_Update");
        Lua_WindowUtil.openWin("Lua_ArtifactSelectWindow", Lua_WinParam.ACTION_CLOSE);
    end
end