--战斗布阵
checkRequire("Lua_BaseLineupWindow");
Lua_FightLineupWindow = class("Lua_FightLineupWindow", Lua_BaseLineupWindow);
function Lua_FightLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_FightLineupWindow";
    self.skinName = "FightLineupWindow_skin";
end

function Lua_FightLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.leftAureoleItem = Lua_HeroLineupAureoleItem.new(self.topObject, 1);
    self.leftAureoleItem:setRectAnchor(1);
    self.leftAureoleItem:setLocation(-294, -44, 0);

    self.rightAureoleItem = Lua_HeroLineupAureoleItem.new(self.topObject, 2);
    self.rightAureoleItem:setRectAnchor(1);
    self.rightAureoleItem:setLocation(294, -44, 0);

    self.btnFight:addClickFuntion(self, self.onBtnFightClick);
    self.one_btn:addClickFuntion(self, self.onOneBtnClick);
end

function Lua_FightLineupWindow:showWin(param)
    self.showData = param;
    if type(param) == "table" then
        self.template_id = param.template_id;
        self.stage_id = param.stage_id;
        if param.default_camp ~= nil then
            self.default_camp = param.default_camp;
        end
        if param.monster_player_id ~= nil then -- 配置表怪物
            self:showEnemyInfo(param.monster_player_id);
        else -- 请求服务端数据
        
        end
    elseif type(param) == "number" then
        self.template_id = param;
    end
    self.lineup_type = Lua_FightTemplateConfigData.getConfigData(self.template_id).lineup_type;
    
    self:showSceneByTemplateId(self.template_id);
    self:updateLineupInfo();
    self:onCampSelected(self.default_camp, true);
end

function Lua_FightLineupWindow:dispose()
    if self.leftAureoleItem ~= nil then
        self.leftAureoleItem:dispose();
        self.leftAureoleItem = nil;
    end
    if self.rightAureoleItem ~= nil then
        self.rightAureoleItem:dispose();
        self.rightAureoleItem = nil;
    end
    if self.enemyLineupPanel ~= nil then
        self.enemyLineupPanel:dispose();
        self.enemyLineupPanel = nil;
    end
    self.serverArtifactDic = nil;
    self.localArtifactDic = nil;
    self:superCall("dispose");
end

-- 更新模型展示
function Lua_FightLineupWindow:updateSceneModel()
    if self.localLineupDic == nil or self.teamIdx == nil then
        return;
    end

    local tab = {};
    local heroVo;
    for k, v in pairs(self.localLineupDic[self.teamIdx]) do
        heroVo = DataCenter.heroData:getItemByUniqueId(v);
        tab[k] = heroVo;
    end

    self:showSceneModel(tab);
end

function Lua_FightLineupWindow:updateLineupNum()
    self.lineupNum = table.length(self.localLineupDic[self.teamIdx]);
    self.show_num.text = LanUtil.formateStr(126310, tostring(self.lineupNum), tostring(self.positionNum));
end

-- 己方光环更新
function Lua_FightLineupWindow:updateAureoleInfo()
    local standDic = self.localLineupDic[self.teamIdx];
    local force = DataCenter.heroLineupData:calcLineupForce(standDic);
    if self.localArtifactDic[self.teamIdx] > 0 then
        force = force + DataCenter.roleData.leaderForce;
    end
    local aureole_list = DataCenter.heroLineupData:getAureoleInfo(standDic);
    local aureole_id = DataCenter.heroLineupUtil:getAureoleId(aureole_list);
    self.leftAureoleItem:setData(aureole_id, DataCenter.roleData.name, force);
end

-- 展示敌方数据
function Lua_FightLineupWindow:showEnemyInfo(monster_player_id)
    local cfgData = Lua_MonsterPlayerConfigData.getConfigData(monster_player_id);
    if cfgData == nil then
        return;
    end
    local aureole_id = cfgData.camp_aureole_id;
    if aureole_id == nil then
        aureole_id = 0;
        local list = cfgData.fighter_list
        if list ~= nil and list[self.teamIdx] ~= nil then
            local dic = list[self.teamIdx];
            local cfgData;
            -- local hidDic = {};
            -- for i = 1, #dic do
            --     cfgData = Lua_MonsterConfigData.getMonsterConfig(dic[i][1]);
            --     if cfgData ~= nil then
            --         hidDic[cfgData.heroVo.id] = dic[i][2];
            --     end
            -- end
            -- local aureole_list = DataCenter.heroLineupData:getAureoleInfoByHidList(hidDic);
            
            local aureole_list = {};
            for i = 1, #dic do
                cfgData = Lua_MonsterConfigData.getMonsterConfig(dic[i][1]);
                if cfgData ~= nil then
                    if aureole_list[cfgData.heroVo.campType] == nil then
                        aureole_list[cfgData.heroVo.campType] = 1;
                    else
                        aureole_list[cfgData.heroVo.campType] = aureole_list[cfgData.heroVo.campType] + 1;
                    end
                end
            end
            aureole_id = DataCenter.heroLineupUtil:getAureoleId(aureole_list);
        end
    end
    self:updateEnemyAureoleInfo(aureole_id, cfgData.name, cfgData.force);
    self:updateEnemyLineup(1, cfgData.fighter_list);
end

-- 敌方光环更新
function Lua_FightLineupWindow:updateEnemyAureoleInfo(aureole_id, name, force)
    self.rightAureoleItem:setData(aureole_id, name, force);
end

-- 九宫格数据更新
function Lua_FightLineupWindow:updateEnemyLineup(dataType, list)
    if list == nil then
        return;
    end

    if self.enemyLineupPanel == nil then
        self.enemyLineupPanel = Lua_HeroGridViewPanel.new(self.content, 1, 2);
        self.enemyLineupPanel:setRectAnchor(1);
        self.enemyLineupPanel:setLocation(223, -200, 0);
        self.enemyLineupPanel:setCanClick(true);
    end
    if dataType == 1 then -- 配置表数据
        self.enemyLineupPanel:setDataByConfig(list[self.teamIdx]);
    elseif dataType == 2 then -- 服务端数据
        self.enemyLineupPanel:setDataByProto(list);
    end
end

--一键上阵
function Lua_FightLineupWindow:onOneBtnClick(go)
    DataCenter.heroLineupData:setHeroOneKey(self.stand_type, self.localLineupDic, self.teamIdx, self.lineup_type);

    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
end

--开始战斗
function Lua_FightLineupWindow:onBtnFightClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.showLangValue(10031);
        return;
    end
    self.clickTime = getTime();

    local recordId = DataCenter.fightData:getRecordIdByTemplateId(self.template_id);
    if recordId > 0 then
        return;
    end
    if DataCenter.guideData.bPlayGuide then--引导中
        self:onStartFight();
    else
        self:onCheckArtifact();
    end
end

function Lua_FightLineupWindow:onCheckArtifact()
    local teamIdx = DataCenter.heroLineupData:checkArtifactIsNull(self.localArtifactDic);
    if teamIdx == nil then
        self:onCheckLineup();
    else
        local artifactId = DataCenter.heroLineupData:getUnWearArtifact(self.localArtifactDic);
        if artifactId == nil then
            self:onCheckLineup();
        else
            if DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.ARTIFACE_SELECT) then
                self:onCheckLineup();
            else
                local tipsData = {
                    des = LanUtil.getValue(126316),
                    posY = 30,
                    neverTip = Lua_NeverTipDefine.ARTIFACE_SELECT,
                    btnType = 1, 
                    owner = self,
                    cancelFun = self.onCheckLineup,
                    sureFun = self.onOpenArtifact
                };
                Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
            end
        end
    end
end

function Lua_FightLineupWindow:onCheckLineup()
    if self.lineupNum == 0 then
        OperateAlert.showLangValue(126307);
        return;
    end

    if self.lineupNum < self.positionNum and DataCenter.heroLineupData:checkPackHaveHero(self.localLineupDic, self.teamIdx) then
        local tipsData = {
            des = LanUtil.getValue(126312),
            font_size = 28,
            posY = 30,
            btnType = 1,
            owner = self,
            sureFun = self.onStartFight
        };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return;
    end

    self:onStartFight();
end

function Lua_FightLineupWindow:onOpenArtifact()
    Lua_WindowUtil.openWin("Lua_ArtifactSelectWindow", Lua_WinParam.ACTION_OPEN, self.localArtifactDic);
end

function Lua_FightLineupWindow:onStartFight()
    local isChange = DataCenter.heroLineupData:checkLineupIsChange(self.teamIdx, self.serverLineupDic, self.localLineupDic);
    if isChange == false then
        isChange = DataCenter.heroLineupData:checkArtifactIsChange(self.teamIdx, self.serverArtifactDic, self.localArtifactDic);
    end
    if isChange == true then
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroSaveLineup(self.lineup_type, self.stand_type, self.localLineupDic, self.localArtifactDic);
    end

    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
end