--光环界面
Lua_HeroLineupAureoleWindow = class("Lua_HeroLineupAureoleWindow", Lua_Window);
function Lua_HeroLineupAureoleWindow:ctor()
    self:superCall("ctor");
    self.isClickClose = true;
    self.showCloseText = true;
    self.closeTextPosY = -348;
    self.showBlackMask = true;
    self.windowName = "Lua_HeroLineupAureoleWindow";
    self.skinName="HeroLineupAureoleWindow_skin";
end

function Lua_HeroLineupAureoleWindow:buildShowItem()
    self:superCall("buildShowItem");
    LuaUtil.setObjScale(self.icon_obj1, 0.5, 0.5, 0.5);
    LuaUtil.setObjScale(self.icon_obj2, 0.5, 0.5, 0.5);
    LuaUtil.setObjScale(self.icon_obj3, 0.5, 0.5, 0.5);
end

function Lua_HeroLineupAureoleWindow:showWin(aureole_id)
	self.aureole_id = aureole_id;
    self:showInfo();
end

function Lua_HeroLineupAureoleWindow:showInfo()
    local list = getConfig({ "hero_aureole_type"});
    self.aureoleInfo = Array();
    for i=1,#list do
    	if list[i].aureole_type ~= 3 then -- 屏蔽光暗系
    		self["show_des"..i].text = list[i].des;
    		local arr = DataCenter.heroLineupUtil:getAureoleInfoByType(list[i].aureole_type);
    		local item;
    		for j=1,arr:getSize() do
    			item = UICreate.createLabel(self.content, "", 65, -55, 650, 35, 20);
    			item.pivot = Lua_WindowUtil.getPivot(3);
    			item.alignmentValue = 3;
    			item.horizontalOverflowValue = 1;
    			if i == 1 then
    				item:setLocation(-204, 74 - (j-1)*29);
    			elseif i == 2 then
    				item:setLocation(-204, -86 - (j-1)*29);
    			else
    				item:setLocation(-204, -291 - (j-1)*29);
    			end
    			local bool = true;
    			local color = "acacac";
    			if arr[j].id == self.aureole_id then
    				color = "2fea15";
    				bool = false;
    			end
    			self["icon"..i.."_"..j]:setGray(bool);
    			item.text = "<color=#"..color..">"..arr[j].describe.."</color>";
    			self.aureoleInfo:add(item);
    		end
    	end
    end
end

function Lua_HeroLineupAureoleWindow:dispose()
    if self.aureoleInfo ~= nil then
		self.aureoleInfo:dispose();
		self.aureoleInfo:clear();
		self.aureoleInfo = nil;
	end
    self:superCall("dispose");
end