-- 英雄布阵选择Item
Lua_HeroLineupCell = class("Lua_HeroLineupCell", Lua_ListCell);
function Lua_HeroLineupCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroLineupCell:buildShowItem()
    self:superCall("buildShowItem");
    
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(0, 0, 0);
end

function Lua_HeroLineupCell:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self.lockIcon = nil;
    self.selectIcon = nil;
    self.customParam = nil;
    self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroLineupCell:setCustomParam(customParam)
    self.customParam = customParam;
end

function Lua_HeroLineupCell:setData(data)
    self.data = DataCenter.heroData:getItemByUniqueId(data);
    self.itemIcon:setData(self.data);
    self:updateSelected();
end

function Lua_HeroLineupCell:setLock(bLock)
    if bLock == true then
        if self.lockIcon == nil then
            self.lockIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_018_n", 0, 0, 58, 58);
        end
        self.lockIcon:setEnable(true);
    else
        if self.lockIcon ~= nil then
            self.lockIcon:setEnable(false);
        end
    end
end

function Lua_HeroLineupCell:updateSelected()
    local teamIdx, standIdx = DataCenter.heroLineupData:getHeroTeamAndStand(self.customParam, self.data.unique_id);
    self.itemIcon:setDrawMask(standIdx ~= nil);
end

function Lua_HeroLineupCell:onPressClick()
    local isGuiding = DataCenter.guideData.isGuiding;
    if isGuiding then -- 引导点击间隔
        if self.clickTime ~= nil and getTime() - self.clickTime < 0.6 then
            return;
        end
        self.clickTime = getTime();
    end
    
    Lua_MsgUtil.callFunc("LINEUP_HERO_SELECT", self.data.unique_id);
end

function Lua_HeroLineupCell:onLongPressClick()
    if Lua_WindowUtil.isWindowShowing("Lua_HeroTipsWindow") == false then
        Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, self.data);
    end
end