-- 阵法站位
Lua_HeroLineupStandWindow = class("Lua_HeroLineupStandWindow", Lua_Window);
function Lua_HeroLineupStandWindow:ctor()
    self:superCall("ctor");
    
    self.w = 732;
    self.h = 134;
    self.windowName = "Lua_HeroLineupStandWindow";
    self.showBlackMask = true;
    self.showWinBg = true;
    self.winBgAtlas = "common_altas_1";
    self.winBgSprite = "ui_common_window_009";
    self.winBgPosX = 0;
    self.winBgPosY = 0;
    self.isClickClose = true;
end

function Lua_HeroLineupStandWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.standArr = Array();
    local list = DataCenter.heroLineupUtil.standConfigInfo;
    local item;
    for i = 1, #list do
        if list[i].is_show == 1 then
            item = Lua_HeroLineupStandItem.new(self.content);
            item:setLocation(-300 + (i - 1) * 122, 0, 0);
            item:setData(list[i]);
            self.standArr:add(item);
        end
    end
end

function Lua_HeroLineupStandWindow:dispose()
    if self.standArr ~= nil then
        self.standArr:dispose();
        self.standArr:clear();
        self.standArr = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroLineupStandWindow:showWin(param)
    self:superCall("showWin", param);

    for i = 1, self.standArr:getSize() do
        self.standArr[i]:setSelected(self.standArr[i].stand_type == param);
    end
end




















Lua_HeroLineupStandItem = class("Lua_HeroLineupStandItem", Lua_DisplayObject);
function Lua_HeroLineupStandItem:ctor(p)
    self:superCall("ctor", p, "HeroLineupStandItem_skin");
end

function Lua_HeroLineupStandItem:buildShowItem()
	self:superCall("buildShowItem");

    self.select:setEnable(false);
    self.icon:addClickFuntion(self, self.onIconClick);
end

function Lua_HeroLineupStandItem:dispose()
	self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroLineupStandItem:setData(data)
    self.data = data;
    self.stand_type = data.id;
    self.name.text = data.name;
    self.unlock = data.unlock_lvl <= DataCenter.roleData.level;--是否激活阵型
    self.icon:setGray(not self.unlock)
    self.icon:setAltas("hero_altas_1", data.stand_icon);
end

function Lua_HeroLineupStandItem:setSelected(bSelect)
    self.select:setEnable(bSelect);
end

function Lua_HeroLineupStandItem:onIconClick()
    if self.unlock ~= true then
        OperateAlert.show(LanUtil.formateStr(126320,self.data.unlock_lvl))
    else
        Lua_MsgUtil.callFunc("LINEUP_STANDTYPE_SELECT", self.stand_type);
        Lua_WindowUtil.openWin("Lua_HeroLineupStandWindow", Lua_WinParam.ACTION_CLOSE);
    end
end