--英雄布阵
checkRequire("Lua_BaseLineupWindow");
checkRequire("Lua_HeroLineupTabCell");
Lua_HeroLineupWindow = class("Lua_HeroLineupWindow", Lua_BaseLineupWindow);
function Lua_HeroLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_HeroLineupWindow";
    self.skinName = "HeroLineupWindow_skin";
    self.lineup_type = 0;
end

function Lua_HeroLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    if self.artifactPanel ~= nil then
        self.artifactPanel:setLocation(-282, 676, 0);
    end

    self.forceNum = Lua_NumberImage.new(self.bottomObject);
    self.forceNum:setLocation(-15, 702, 0);
    self.forceNum.pivot = 1;
    self.forceNum.preStr = "ui_zl2_number_0";
    self.forceNum.numOffsetX = -10;
    self.forceNum.num = 0;

    self.aureole_btn:addClickFuntion(self, self.onAureoleBtnClick);
    self.btnSave:addClickFuntion(self, self.onBtnSaveClick);

    self:addLuaEvent("LINEUP_TYPE_SELECT", self, self.onLineupSelected); -- 选择阵营页签更新
    self:addLuaEvent("UPDATE_HERO_LINEUP_INFO", self, self.onLineupInfoUpdate); -- 阵容保存
end

function Lua_HeroLineupWindow:showWin(param)
    self.showData = param;

    -- data = id               是阵容类型     页签就用通用数据展示为主
    -- data = {id1,id2,...}    是阵容类型列表 页签就以这个列表数据展示为主
    if type(param) == "table" then
        local data = param;
        if param.data ~= nil then
            data = param.data;
        end
        local arr, selectIndex = DataCenter.heroLineupUtil:getLineupTabInfo(data);
        if self.tabList == nil then
            self.tabList = Lua_DragList.new(self.bottomObject, 366, 63, Lua_AxisDefine.Horizontal);
            self.tabList:setLocation(-135, 578, 0);
            self.tabList:setListCell(Lua_HeroLineupTabCell, 183, 63, 1);
            self.tabList:setCellSpacing(-6, 0);
        end
        self.tabList.canDrag = arr:getSize() > 3;
        self.tabList:setArrayData(arr);
        self.tabList:moveToIndex(selectIndex);
        self.tabList:setSelected(selectIndex);
        self:onLineupSelected(arr[selectIndex]);
    else
        self.lineup_type = param;
        self:showSceneByLineupType(self.lineup_type);
        self:updateLineupInfo();
        self:onCampSelected(Lua_HeroUtil.All_TYPE, true);
    end
end

function Lua_HeroLineupWindow:dispose()
    if self.forceNum ~= nil then
        self.forceNum:dispose();
        self.forceNum = nil;
    end
    if self.tabList ~= nil then
        self.tabList:dispose();
        self.tabList = nil;
    end
    if self.aureoleAttrArr ~= nil then
        self.aureoleAttrArr:clear();
        self.aureoleAttrArr:dispose()
        self.aureoleAttrArr = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroLineupWindow:onLineupSelected(tabVo)
    if self.lineup_type == tabVo.id then
        return;
    end

    self:showSceneByLineupType(tabVo.id);
    if self.lineup_type == 0 then -- 第一次进入界面
        self.lineup_type = tabVo.id;
        self:updateLineupInfo();
    else
        local isChange = self:checkLineupIsChange();
        if isChange == true then
            self.prev_lineup_type = self.lineup_type;
            self.lineup_type = tabVo.id;
            self:showTipsWindow();
        else
            self.prev_lineup_type = nil;
            self.lineup_type = tabVo.id;
            self:updateLineupInfo();
        end
    end

    self:onCampSelected(self.default_camp, true);
end

-- 更新模型展示
function Lua_HeroLineupWindow:updateSceneModel()
    if self.localLineupDic == nil or self.teamIdx == nil then
        return;
    end

    local tab = {};
    local heroVo;
    for k, v in pairs(self.localLineupDic[self.teamIdx]) do
        heroVo = DataCenter.heroData:getItemByUniqueId(v);
        tab[k] = heroVo;
    end

    self:showSceneModel(tab);
end

function Lua_HeroLineupWindow:updateLineupNum()
    self.lineupNum = table.length(self.localLineupDic[self.teamIdx]);
    self.show_num.text = LanUtil.formateStr(126310, tostring(self.lineupNum), tostring(self.positionNum));
end

-- 更新光环
function Lua_HeroLineupWindow:updateAureoleInfo()
    local standDic = self.localLineupDic[self.teamIdx];
    local aureole_list = DataCenter.heroLineupData:getAureoleInfo(standDic);
    self.aureole_id = DataCenter.heroLineupUtil:getAureoleId(aureole_list);
    local config = DataCenter.heroLineupUtil:getAureoleConfig(self.aureole_id);

    if self.aureole_id ~= nil and config ~= nil then
        local arr = DataCenter.heroLineupUtil:getAureoleAttrInfo(self.aureole_id);
        self:showAureoleAttrItem(arr);
        self.aureole_bg:setEnable(true);
        self.aureole_btn:setAltas("hero_altas_1", config.sprite);
    else
        self:showAureoleAttrItem(nil);
        self.aureole_bg:setEnable(false);
        self.aureole_btn:setAltas("hero_altas_1", "halo01");
    end

    -- 更新战力
    local force = DataCenter.heroLineupData:calcLineupForce(self.localLineupDic[self.teamIdx]);
    if self.localArtifactDic[self.teamIdx] > 0 then
        force = force + DataCenter.roleData.leaderForce;
    end
    self.forceNum.num = force;
end

-- 光环属性
function Lua_HeroLineupWindow:showAureoleAttrItem(arr)
    if arr ~= nil then  
        if self.aureoleAttrArr == nil then
            self.aureoleAttrArr = Array();
        end
        local len = self.aureoleAttrArr:getSize();
        for i = 1, len do
            self.aureoleAttrArr[i]:setEnable(false);
        end
        local item;
        local w = 0;
        local itemW = 0;
        local x = -260;
        for i = 1, arr:getSize() do
            if self.aureoleAttrArr[i] ~= nil then
                item = self.aureoleAttrArr[i];
            else
                item = Lua_HeroAureoleAttrItem.new(self.topObject);
                self.aureoleAttrArr:add(item);
            end
            item:setData(arr[i]);
            item:setEnable(true);

            x = x + itemW;
            itemW = item.itemW;
            w = itemW + w;
            item:setLocation(x, -35.5, 0);
        end

        self.aureole_bg:SetDimensions(80+w, 66);
    else
        if self.aureoleAttrArr ~= nil then
            local len = self.aureoleAttrArr:getSize();
            for i = 1, len do
                self.aureoleAttrArr[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroLineupWindow:onLineupInfoUpdate(lineup_type)
    self:updateLineupInfo();
    self:updateHeroList();
end

-- 光环
function Lua_HeroLineupWindow:onAureoleBtnClick(go)
    Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_OPEN, self.aureole_id);
end

-- 布阵改变提示
function Lua_HeroLineupWindow:showTipsWindow()
    local tipData = { des = LanUtil.getValue(126306), posY = 30, btnType = 1, onFunType = 0,
    owner = self, cancelFun = self.onCancelFun, sureFun = self.onSureFun };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroLineupWindow:onCancelFun()
    if self.prev_lineup_type ~= nil then -- 切换页签
        self.prev_lineup_type = nil;
        self:onLineupInfoUpdate();
    else
        self:hide();
    end
end

function Lua_HeroLineupWindow:onSureFun()
    local configData = Lua_HeroLineupCofingData.getConfigData(self.lineup_type);
    if self.lineupNum == 0 and configData.can_nil == 0 then
        OperateAlert.showLangValue(126307);
        self:onLineupInfoUpdate();
        return;
    end

    if self.prev_lineup_type ~= nil then
        self:onSaveLineup(self.prev_lineup_type);
        self.prev_lineup_type = nil;
    else
        self:onSaveLineup(self.lineup_type);
    end

    if self.needCloseWin == true then
        self:hide();
    end
end

function Lua_HeroLineupWindow:onBackBtnClick(go)
    local isChange = self:checkLineupIsChange();
    if isChange == false then
        isChange = DataCenter.heroLineupData:checkArtifactIsChange(self.teamIdx, self.serverArtifactDic, self.localArtifactDic);
    end
    if isChange == true then
        self.needCloseWin = true;
        self:showTipsWindow();
    else
        self:hide();
    end
end

-- 保存
function Lua_HeroLineupWindow:onBtnSaveClick()
    local isChange = self:checkLineupIsChange();
    if isChange == false then
        isChange = DataCenter.heroLineupData:checkArtifactIsChange(self.teamIdx, self.serverArtifactDic, self.localArtifactDic);
    end
    if isChange == false then
        return;
    end

    local configData = Lua_HeroLineupCofingData.getConfigData(self.lineup_type);
    if self.lineupNum == 0 and configData.can_nil == 0 then
        OperateAlert.showLangValue(126307);
        return;
    end

    self:onSaveLineup(self.lineup_type);
    if self.needCloseWin == true then
        self:hide();
    end
end

--发送阵容保存
function Lua_HeroLineupWindow:onSaveLineup(lineup_type)
    -- for teamIdx, standDic in pairs(self.localLineupDic) do
    --     for standIdx, hero_uid in pairs(standDic) do
    --         print(standIdx, hero_uid)
    --     end
    -- end
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroSaveLineup(lineup_type, self.stand_type, self.localLineupDic, self.localArtifactDic);
    if type(self.showData) == "table" and self.showData.isSaveClose == true then
        self:hide();
    end
end


--阵容是否发生变化
function Lua_HeroLineupWindow:checkLineupIsChange()
    if self.tag_stand ~= self.stand_type then--阵型发生变化
        return true;
    end
    --1阵型和6阵型更换，英雄站位索引存在不会发生改变，这里不能作为阵型变化判断 
    return DataCenter.heroLineupData:checkLineupIsChange(self.teamIdx, self.serverLineupDic, self.localLineupDic);
end














-- 光环属性item
Lua_HeroAureoleAttrItem = class("Lua_HeroAureoleAttrItem", Lua_DisplayObject);
function Lua_HeroAureoleAttrItem:ctor(p)
    self:superCall("ctor", p, "HeroAureoleAttrItem_skin");
end

function Lua_HeroAureoleAttrItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroAureoleAttrItem:setData(attrVo)
    self.attr_value.text = "+"..attrVo.showValue;
    self.attr_value:resetSize();
    self.attr_icon:setAltas("common_altas_2", attrVo.attr_icon_1);
end

function Lua_HeroAureoleAttrItem.Get:itemW()
    return 35 + self.attr_value.width;
end

function Lua_HeroAureoleAttrItem:dispose()
    self:superCall("dispose");
end