--寂灭岛副本布阵
checkRequire("Lua_FightLineupWindow")
Lua_EquipCopyLineupWindow = class("Lua_EquipCopyLineupWindow", Lua_FightLineupWindow);
function Lua_EquipCopyLineupWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_EquipCopyLineupWindow";
end

function Lua_EquipCopyLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.heroList:setListCell(Lua_EquipCopyLineupCell, 112, 112, 5);

    -- self.showBossPanel = Lua_ShowBossPanel.new(self.content);
    -- self.showBossPanel:setLocation(230,470,0);

    self.desTxt = UICreate.createLabel(self.topObject, "", 230, -330, 100, 40, 24);
    self.desTxt.fontName = Lua_MyUISettings.huakangFontName;
    self.desTxt.horizontalOverflowValue = 1;
    self.desTxt.verticalOverflowValue = 1;
    self.desTxt.alignmentValue = 4;

    if self.rightAureoleItem ~= nil then
        self.rightAureoleItem.force_icon:setEnable(false);
        self.rightAureoleItem:setClick(self, self.onShowTip);
    end
end

function Lua_EquipCopyLineupWindow:dispose()
    DataCenter.equipCopyData.subdue_camp = nil;
    self:superCall("dispose")
end

function Lua_EquipCopyLineupWindow:showWin(param)
    -- param.copyData; -- 副本信息;
    -- param.stage_id; -- 关卡id
    -- param.template_id; -- 战斗模板
    -- param.monster_player_id; -- 配置表怪物
    self.showData = param;
    self.template_id = param.template_id;
    self.lineup_type = param.copyData.lineup;
    DataCenter.equipCopyData.subdue_camp = param.copyData.subdue_camp;--克制阵营

    if self.template_id == DataCenter.equipCopyUtil.more_template_id then
        self.btnFight:setLangValue(420005);
    end

    self:showSceneByTemplateId(self.template_id);
    self:updateLineupInfo();
    self:onCampSelected(Lua_HeroUtil.All_TYPE);

    -- self.showBossPanel:setData(param.copyData);

    self:showEnemyInfo(param.monster_player_id);
    self.desTxt.text = param.copyData.des;
end

-- 敌方光环更新
function Lua_EquipCopyLineupWindow:updateEnemyAureoleInfo(aureole_id, name, force)
    self.rightAureoleItem:setData(0, name, force);
end

function Lua_EquipCopyLineupWindow:onShowTip()
    OperateAlert.showLangValue(420126);
end

function Lua_EquipCopyLineupWindow:onBtnFightClick(go)
    if self.template_id == DataCenter.equipCopyUtil.single_template_id then
        self:onCheckArtifact();
    else
        self:onSaveLineup();
    end
end

function Lua_EquipCopyLineupWindow:onStartFight()
    self:onSaveLineup();
    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.showData.stage_id);
end

function Lua_EquipCopyLineupWindow:onSaveLineup()
    local isChange = DataCenter.heroLineupData:checkLineupIsChange(self.teamIdx, self.serverLineupDic, self.localLineupDic);
    if isChange == false then
        isChange = DataCenter.heroLineupData:checkArtifactIsChange(self.teamIdx, self.serverArtifactDic, self.localArtifactDic);
    end
    if isChange == true then
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroSaveLineup(self.lineup_type, self.stand_type, self.localLineupDic, self.localArtifactDic);
    end
end

























Lua_EquipCopyLineupCell = class("Lua_EquipCopyLineupCell", Lua_HeroLineupCell);

function Lua_EquipCopyLineupCell:buildShowItem()
    self:superCall("buildShowItem");

    self.arrows = UICreate.createUIAtlasImage(self.content, "common_altas_3", "ui_djc_label_06", 40, 35, 0, 0);
    self.arrows:setEnable(true);
end

function Lua_EquipCopyLineupCell:setData(data)
    self:superCall("setData",data);

    if self.data.campType == DataCenter.equipCopyData.subdue_camp then
        self.arrows:setEnable(true);
    else
        self.arrows:setEnable(false);
    end
end






















--boss信息
Lua_ShowBossPanel = class("Lua_ShowBossPanel", Lua_DisplayObject);

function Lua_ShowBossPanel:ctor(p)
    self:superCall("ctor", p,"ShowBossPanel_skin");
end

function Lua_ShowBossPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.head:addClickFuntion(self, self.onHeadBtnClick);
end

function Lua_ShowBossPanel:setData(data)
    self.bossId = data.id;
    self.des.text = data.des;
    self.name.text = data.boss_name;
    self.head:setAltas("common_altas_3", data.boss_head);
    self.icon:setAltas("common_altas_2", "ui_common_button_0"..(data.id + 25).."_n");
end

function Lua_ShowBossPanel:onHeadBtnClick()
    Lua_WindowUtil.openWin("Lua_BossStrategyWindow", Lua_WinParam.ACTION_OPEN, {bTeam = false, id = self.bossId});
end

function Lua_ShowBossPanel:dispose()
    self:superCall("dispose");
end
