-- 无穷战殿 个人布阵
checkRequire("Lua_FightLineupWindow");
Lua_InfinityHallIndividualWindow = class("Lua_InfinityHallIndividualWindow", Lua_FightLineupWindow);
function Lua_InfinityHallIndividualWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_InfinityHallIndividualWindow";
	self.skinName = "FightLineupWindow_skin";
end

function Lua_InfinityHallIndividualWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.checkHelp = UICreate.createUIAtlasImage(self.topObject, "common_altas_1", "ui_common_button_016_n", -320, -215, 0, 0);

	self.promptText = UICreate.createLabel(self.topObject, LanUtil.getValue(126322), -235, -215, 100, 31, 22);
	self.promptText.alignmentValue = 3;
	self.promptText.horizontalOverflowValue = 1;

	self.stand_bg:setEnable(false)
	self.stand_btn:setEnable(false)
	self.show_num:setEnable(false)
	self.one_btn:setEnable(false);
end

function Lua_InfinityHallIndividualWindow:dispose()
	if self.teamArr ~= nil then
		self.teamArr:dispose();
		self.teamArr:clear();
		self.teamArr = nil;
	end
	self:superCall("dispose");
end

function Lua_InfinityHallIndividualWindow:showWin(param)
	self.showData = param;
	self.stand_type = 7; -- 站位类型
	self.template_id = param.template_id;
	self.lineup_type = Lua_FightTemplateConfigData.getConfigData(self.template_id).lineup_type;

	self:showSceneByTemplateId(self.template_id);
	self:updateLineupInfo();
	self:showEnemyInfo(param.monster_player_id);
	self:onCampSelected(self.default_camp, true);

	self.team_number = Lua_HeroLineupCofingData.getConfigData(self.lineup_type).team_number;
	self:updateTeamInfo();
end

function Lua_InfinityHallIndividualWindow:updateLineupNum()

end

function Lua_InfinityHallIndividualWindow:updateTeamInfo()
	if self.teamArr == nil then
		self.teamArr = Array();
	end
	local item;
	for i = 1, self.team_number do
		item = self.teamArr[i];
		if item == nil then
			item = Lua_InfinityHallLineupTeamItem.new(self.bottomObject);
			self.teamArr:add(item);
		end
		item:setLocation(i * 120 - 240, 800, 0);
		item:setIndex(i);
		item:setData(self.localLineupDic[i]);
	end	
end

function Lua_InfinityHallIndividualWindow:onHeroSelected(uniqueId)
	local teamIdx, standIdx = DataCenter.heroLineupData:getHeroTeamAndStand(self.localLineupDic, uniqueId);
	if standIdx == nil then -- 未上阵
		teamIdx, standIdx = self:getTeamAndStandIdx();
		if teamIdx == nil or standIdx == nil then -- 上阵英雄已达上限
			OperateAlert.showLangValue(126300);
			return;
		end

		local isInLineup = DataCenter.heroLineupData:checkHeroInLineup(self.localLineupDic, uniqueId);
        if isInLineup == true then -- 不能同时上阵2个相同的英雄
            OperateAlert.showLangValue(126302);
            return;
        end

        self.localLineupDic[teamIdx][standIdx] = uniqueId;
	else -- 已上阵
        self.localLineupDic[teamIdx][standIdx] = nil;
	end

    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateAureoleInfo();
    self:updateTeamInfo();
end

function Lua_InfinityHallIndividualWindow:getTeamAndStandIdx()
	local teamIdx = 0;
	local standIdx;
	while teamIdx < self.team_number do
		teamIdx = teamIdx + 1;
		standIdx = DataCenter.heroLineupData:getNullStandIdx(self.stand_type, self.localLineupDic, teamIdx);
		if standIdx ~= nil then
			return teamIdx, standIdx;
		end
	end
	return nil, nil;
end

function Lua_InfinityHallIndividualWindow:onHeroCampPosChange(uid)
	self:superCall("onHeroCampPosChange", uid);
	self:updateTeamInfo();
end

function Lua_InfinityHallIndividualWindow:onCheckLineup()
	local num = 0;
	for teamIdx, standDic in pairs(self.localLineupDic) do
		if table.length(standDic) > 0 then
			num = num + 1;
		end
	end

	if num == 0 then
		OperateAlert.showLangValue(126307);
		return;
	end

	if num < self.team_number and self:checkPackHaveHero() then
		local tipsData = { des = LanUtil.getValue(126319), btnType = 1, owner = self, sureFun = self.onStartFight };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onStartFight();
	end
end

function Lua_InfinityHallIndividualWindow:checkPackHaveHero()
	local existDic = {} --已上阵英雄
	local heroId
	for teamIdx, standDic in pairs(self.localLineupDic) do
		for stand, uid in pairs(standDic) do
			heroId = DataCenter.heroData:getItemByUniqueId(uid).id
			existDic[heroId] = stand
		end
	end

    local arr = DataCenter.heroData.heroUidArr
    for i = 1, arr:getSize() do
        heroId = DataCenter.heroData:getItemByUniqueId(arr[i]).id
        if existDic[heroId] == nil then
            return true
        end
    end
    return false
end

function Lua_InfinityHallIndividualWindow:onCheckArtifact()
    if self.localArtifactDic[self.teamIdx] == 0 then
        local artifactId = DataCenter.heroLineupData:getUnWearArtifact(self.localArtifactDic);
        if artifactId == nil then
            self:onCheckLineup();
        else
            if DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.ARTIFACE_SELECT) then
                self:onCheckLineup();
            else
                local tipsData = { des = LanUtil.getValue(126316), posY = 30, btnType = 1, 
                owner = self, cancelFun = self.onCheckLineup, sureFun = self.onOpenArtifact, neverTip = Lua_NeverTipDefine.ARTIFACE_SELECT };
                Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
            end
        end
    else
    	self:onCheckLineup();
    end
end

function Lua_InfinityHallIndividualWindow:onStartFight()
	if self:checkLineupIsChange() == true then
		Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroSaveLineup(self.lineup_type, self.stand_type, self.localLineupDic, self.localArtifactDic);
	end

	Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.InfinityHall_Fight, false, true)
end

function Lua_InfinityHallIndividualWindow:checkLineupIsChange()
	local teamIdx = 0;
	local isChange;
	while teamIdx < self.team_number do
		teamIdx = teamIdx + 1;
		isChange = DataCenter.heroLineupData:checkLineupIsChange(teamIdx, self.serverLineupDic, self.localLineupDic);
		if isChange == false then
			isChange = DataCenter.heroLineupData:checkArtifactIsChange(teamIdx, self.serverArtifactDic, self.localArtifactDic);
		end
		if isChange == true then
			return true;
		end
	end
	return false;	
end





















Lua_InfinityHallLineupTeamItem = class("Lua_InfinityHallLineupTeamItem", Lua_DisplayObject);
function Lua_InfinityHallLineupTeamItem:ctor(p)
	self:superCall("ctor", p);
	self.teamIdx = 1;
end

function Lua_InfinityHallLineupTeamItem:buildShowItem()
	self:superCall("buildShowItem");

	self.nameText = UICreate.createLabel(self.content, "", 0, 70, 100, 31, 22);
	self.nameText.pivot = Lua_WindowUtil.getPivot(4);
	self.nameText.alignmentValue = 4;
	self.nameText.horizontalOverflowValue = 1;

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
end

function Lua_InfinityHallLineupTeamItem:dispose()
	self.nameText = nil;
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_InfinityHallLineupTeamItem:setIndex(index)
	self.teamIdx = index;
	if index == 1 then
		self.nameText:setLangValue(304023);
	else
		self.nameText:setLangValue(304024);
	end
end

function Lua_InfinityHallLineupTeamItem:setData(tab)
	local uid;
	for k, v in pairs(tab) do
		uid = v;
	end

	if uid == nil or uid <= 0 then
		self.itemIcon:setData(nil);
	else
		self.itemIcon:setData(DataCenter.heroData:getItemByUniqueId(uid));
	end
end