--新英雄主题活动 战斗布阵Window
checkRequire("Lua_FightLineupWindow");
Lua_NewHeroActStoryLineupWindow = class("Lua_NewHeroActStoryLineupWindow", Lua_FightLineupWindow);
function Lua_NewHeroActStoryLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_NewHeroActStoryLineupWindow";
end

function Lua_NewHeroActStoryLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.heroList:setListCell(Lua_NewHeroActStoryLineupItem, 112, 112, 5);
end

function Lua_NewHeroActStoryLineupWindow:dispose()
    self:superCall("dispose");
end

function Lua_NewHeroActStoryLineupWindow:showWin(param)
    self.showData = param;

    self.template_id = param.template_id;
    self.stage_id = param.stage_id;

    if DataCenter.newHeroActData.heroLineup ~= nil then
        local info = { lineup_type = Lua_HeroUtil.LINEUP_STORY, detachment_list = DataCenter.newHeroActData.heroLineup };
        DataCenter.heroLineupData:addLineupInfo(info);
    end

    self.lineup_type = Lua_HeroUtil.LINEUP_STORY;
    self:showSceneByTemplateId(self.template_id);
    self:updateLineupInfo();
    self:onCampSelected(self.default_camp, true);
end

-- 更新布阵信息
function Lua_NewHeroActStoryLineupWindow:updateLineupInfo()
    self.serverLineupDic = DataCenter.heroLineupData:getServerLineupDic(self.lineup_type); -- 服务端布阵信息
    self.localLineupDic = DataCenter.heroLineupData:getLocalLineupDic(self.serverLineupDic); -- 客户端布阵信息

    self.serverArtifactDic = DataCenter.heroLineupData:getServerArtifactDic(self.lineup_type); -- 服务端神器信息
    self.localArtifactDic = DataCenter.heroLineupData:getLocalArtifactDic(self.serverArtifactDic); -- 客户端神器信息

    self.heroList.customParam = self.localLineupDic;

    -- 站位类型
    self.stand_type = DataCenter.heroLineupData:getServerStandType(self.lineup_type, self.teamIdx);
    if self.stand_btn ~= nil then
        local data = DataCenter.heroLineupUtil:getStandInfoByType(self.stand_type);
        self.stand_btn:setAltas("hero_altas_1", data.stand_icon);
    end

    self.sceneStandType = nil;
    self:updateScenePosEff(self.stand_type);
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
end

function Lua_NewHeroActStoryLineupWindow:updateHeroList()
    local arr = DataCenter.newHeroActData.heroVoArr;
    self.heroList:setArrayData(arr); -- 剧情布阵可选英雄列表
    self:showNone(arr == nil or arr:getSize() <= 0);
end

function Lua_NewHeroActStoryLineupWindow:onHeroSelected(uniqueId)
    local teamIdx, standIdx = DataCenter.heroLineupData:getHeroTeamAndStand(self.localLineupDic, uniqueId);
    if standIdx == nil then -- 未上阵
        standIdx = DataCenter.heroLineupData:getNullStandIdx(self.stand_type, self.localLineupDic, self.teamIdx);
        if standIdx == nil then -- 上阵英雄已达上限
            OperateAlert.showLangValue(126300);
            return;
        end

        self.localLineupDic[self.teamIdx][standIdx] = uniqueId;
    else -- 已上阵
        self.localLineupDic[self.teamIdx][standIdx] = nil;
    end

    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
end

-- 更新模型展示
function Lua_NewHeroActStoryLineupWindow:updateSceneModel()
    if self.localLineupDic == nil or self.teamIdx == nil then
        return;
    end

    local tab = {};
    local heroVo;
    for k, v in pairs(self.localLineupDic[self.teamIdx]) do
        heroVo = DataCenter.newHeroActData.heroUidList[v];
        tab[k] = heroVo;
    end

    self:showSceneModel(tab);
end

-- 己方光环更新
function Lua_NewHeroActStoryLineupWindow:updateAureoleInfo()
    local standDic = self.localLineupDic[self.teamIdx];
    local force = self:calcLineupForce(standDic);
    local aureole_list = self:getAureoleInfo(standDic);
    local aureole_id = DataCenter.heroLineupUtil:getAureoleId(aureole_list);
    self.leftAureoleItem:setData(aureole_id, DataCenter.roleData.name, force);
end

-- 布阵战力
function Lua_NewHeroActStoryLineupWindow:calcLineupForce(tab)
    local force = 0;
    local heroVo;
    for k, v in pairs(tab) do
        heroVo = DataCenter.newHeroActData.heroUidList[v];
        if heroVo ~= nil then
            force = force + heroVo.heroForce;
        end
    end
    if self.localArtifactDic[self.teamIdx] > 0 then
        force = force + DataCenter.roleData.leaderForce;
    end
    return force;
end

-- 站位
function Lua_NewHeroActStoryLineupWindow:getAureoleInfo(standDic)
    local tab = {};
    local heroVo;
    for k, v in pairs(standDic) do
        heroVo = DataCenter.newHeroActData.heroUidList[v];
        if heroVo ~= nil then
            if tab[heroVo.campType] == nil then
                tab[heroVo.campType] = 1;
            else
                tab[heroVo.campType] = tab[heroVo.campType] + 1;
            end
        end
    end
    return tab;
end

function Lua_NewHeroActStoryLineupWindow:onStartFight()
    local isChange = DataCenter.heroLineupData:checkLineupIsChange(self.teamIdx, self.serverLineupDic, self.localLineupDic);
    if isChange == false then
        isChange = DataCenter.heroLineupData:checkArtifactIsChange(self.teamIdx, self.serverArtifactDic, self.localArtifactDic);
    end
    if isChange == true then
        -- 设置新的阵容
        Lua_MsgUtil.callFunc("SET_NEWHEROSTORY_LINEUP_INFO", {stage_id = self.stage_id, stand_type = self.stand_type, hero_lineup = self.localLineupDic, artifact_list = self.localArtifactDic});
    end

    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
end





--------------------------------------------------





Lua_NewHeroActStoryLineupItem = class("Lua_NewHeroActStoryLineupItem", Lua_HeroLineupCell);
function Lua_NewHeroActStoryLineupItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_NewHeroActStoryLineupItem:setData(data)
    self.data = data;
    if data == nil then
        return;
    end
    
    self.itemIcon:setData(data);
    self:updateSelected();
end

function Lua_NewHeroActStoryLineupItem:onPressClick()
    if DataCenter.newHeroActData:checkLeadHero(self.data.unique_id)then
        OperateAlert.show("主角不能下阵");
        return false;
    else
        Lua_MsgUtil.callFunc("LINEUP_HERO_SELECT", self.data.unique_id);
        return true;
    end
end

function Lua_NewHeroActStoryLineupItem:dispose()
    self:superCall("dispose");
end