-- 星魂试炼 战斗布阵Window
checkRequire("Lua_FightLineupWindow");
checkRequire("Lua_StarTrialStarItem");
Lua_StarTrialLineupWindow = class("Lua_StarTrialLineupWindow", Lua_FightLineupWindow);
function Lua_StarTrialLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_StarTrialLineupWindow";
end

function Lua_StarTrialLineupWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.condItemArr = Array();
end

function Lua_StarTrialLineupWindow:showWin(param)
    self:superCall("showWin", param);
    self:updateStarCond();
end

function Lua_StarTrialLineupWindow:dispose()
    if self.condItemArr ~= nil then
        self.condItemArr:dispose();
        self.condItemArr = nil;
    end
    self:superCall("dispose")
end

--选择英雄
function Lua_StarTrialLineupWindow:onHeroSelected(uniqueId)
    self:superCall("onHeroSelected", uniqueId);
    self:updateStarCond();
end

function Lua_StarTrialLineupWindow:updateStarCond()
    local campCareerDic, campDic, careerDic = self:calcData();
    local stageVo = DataCenter.starTrialUitl:getStageVo(self.showData.stage_id);
    local arr = stageVo.starCondArr;
    local len = arr:getSize();
    for i = 1, len do
        arr[i]:init();
        arr[i]:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
        arr[i]:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);
    end
    local item;
    for i = 1, len do
        item = self.condItemArr[i];
        if item == nil then
            item = Lua_StarTrialStarItem.new(self.content);
            self.condItemArr:add(item);
        end
        item:setLocation(-150, 500 - (i -1) * 50, 0);
        item:setData(arr[i]);
    end
end

function Lua_StarTrialLineupWindow:calcData()
    local vo;
    local campCareerDic = {};
    local campDic = {};
    local careerDic = {};
    local num = 0;
    for k, v in pairs(self.localLineupDic[self.teamIdx]) do
        vo = DataCenter.heroData:getItemByUniqueId(v);

        if campCareerDic[vo.campType] == nil then
            campCareerDic[vo.campType] = {};
        end
        if campCareerDic[vo.campType][vo.career] == nil then
            campCareerDic[vo.campType][vo.career] = 1;
        else
            campCareerDic[vo.campType][vo.career] = campCareerDic[vo.campType][vo.career] + 1;
        end
        if campDic[vo.campType] == nil then
            campDic[vo.campType] = 1;
        else
            campDic[vo.campType] = campDic[vo.campType] + 1;
        end
        if careerDic[vo.career] == nil then
            careerDic[vo.career] = 1;
        else
            careerDic[vo.career] = careerDic[vo.career] + 1;
        end
        num = num + 1;
    end

    -- for campType, tab in pairs(campCareerDic) do
    --     for career, n in pairs(tab) do
    --         print(campType, career, n)
    --     end
    -- end
    return campCareerDic, campDic, careerDic;
end

-- 一键上阵
function Lua_StarTrialLineupWindow:onOneBtnClick(go)
    local value = DataCenter.starTrialUitl:getConstConfig("line_up_one_key", "value");
    value = value == nil and 0 or value;
    local curChapter = DataCenter.starTrialData.curChapter;
    if curChapter - 1 < value then
        OperateAlert.show(LanUtil.formateStr("通关第{1}章后开启", tostring(value)));
        return;
    end

    local info = DataCenter.heroLineupUtil:getStandInfoByType(self.stand_type);
    local standDic = self.localLineupDic[self.teamIdx];
    local need_num = #info.position_list;
    local lineup_num = table.length(standDic);
    if lineup_num >= need_num then
        return;
    end
    need_num = need_num - lineup_num;

    local heroId;
    local existDic = {};
    for stand, uid in pairs(standDic) do
        heroId = DataCenter.heroData:getItemByUniqueId(uid).id;
        existDic[heroId] = stand;
    end

    local stageVo = DataCenter.starTrialUitl:getStageVo(self.showData.stage_id);
    local starVo = stageVo.starCondArr[2];
    
    local arr = DataCenter.heroLineupData:getHeroList(Lua_HeroUtil.All_TYPE, self.lineup_type, self.teamIdx, 1);
    local len = arr:getSize();
    local standIdx;
    local heroVo;
    for i = 1, #info.position_list do
        standIdx = info.position_list[i];
        if standDic[standIdx] == nil then
            for j = 1, len do
                heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
                if existDic[heroVo.id] == nil then
                    if starVo.isMeet then -- 星级条件满足
                        self:setHeroLineup(standDic, standIdx, heroVo, existDic);
                        need_num = need_num - 1;
                        break;
                    else
                        local condVo = starVo:getUnMeetVo();
                        if condVo.value1 == 0 then
                            if condVo.value2 == 0 then
                                self:setHeroLineup(standDic, standIdx, heroVo, existDic, starVo);
                                need_num = need_num - 1;
                                break;
                            else
                                if heroVo.career == condVo.value2 then
                                    self:setHeroLineup(standDic, standIdx, heroVo, existDic, starVo);
                                    need_num = need_num - 1;
                                    break;
                                end
                            end
                        else
                            if condVo.value2 == 0 then
                                if heroVo.campType == condVo.value1 then
                                    self:setHeroLineup(standDic, standIdx, heroVo, existDic, starVo);
                                    need_num = need_num - 1;
                                    break;
                                end
                            else
                                if heroVo.campType == condVo.value1 and heroVo.career == condVo.value2 then
                                    self:setHeroLineup(standDic, standIdx, heroVo, existDic, starVo);
                                    need_num = need_num - 1;
                                    break;
                                end
                            end
                        end
                    end
                end
            end

            if need_num == 0 then
                break;
            end
        end
    end

    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
    self:updateStarCond();
end

function Lua_StarTrialLineupWindow:setHeroLineup(standDic, standIdx, heroVo, existDic, starVo)
    standDic[standIdx] = heroVo.unique_id;
    existDic[heroVo.id] = standIdx;
    if starVo ~= nil then
        local campCareerDic, campDic, careerDic = self:calcData();
        starVo:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
        starVo:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);
    end
end